summaryrefslogtreecommitdiff
path: root/postfix/postfix.sh
blob: 62d10c36521a423c2df2d04b676e0f866a648e6b (plain)
  1. #!/bin/sh
  2. #
  3. # /etc/local-COMMON/postfix/postfix.sh
  4. # Copyright 2002-2010,2013-2016,2020 Jonas Smedegaard <dr@jones.dk>
  5. #
  6. # Auto-tweak plain installed postfix Debian package
  7. #
  8. # TODO:
  9. # * Implement stuff from here: http://www.wsrcc.com/spam/
  10. # * Implement stuff from here: http://www.muine.org/~hoang/postfix.html
  11. # * Implement stuff from here: http://jimsun.linxnet.com/misc/postfix-anti-UCE.txt
  12. # * Figure out a way to use chroot jail for TLS stuff.
  13. # * Use https://www.dnswl.org/
  14. set -e
  15. # Let's standardize sort
  16. export LC_ALL=C
  17. warn() {
  18. echo >&2 "Warning: $1"
  19. }
  20. exit1() {
  21. echo >&2 "Error: $1"
  22. echo >&2 "Exiting..."
  23. exit 1
  24. }
  25. FORCE=${FORCE:-}
  26. REDPILL=${REDPILL:-REDPILL}
  27. REALM=${REALM:-ORG}
  28. TLS_CERT=${TLS_CERT:-/etc/ssl/certs/postfix.pem}
  29. TLS_KEY=${TLS_KEY:-/etc/ssl/private/postfix.pem}
  30. # TODO: maybe use AMaViS default of 20 (and instead tune spamassassin)
  31. # <https://www.ijs.si/software/amavisd/amavisd-new-docs.html#max_requests>
  32. AMAVIS_MAXPROC=${AMAVIS_MAXPROC:-2}
  33. # TODO: check if DKIMPROXY_MAXPROC_IN should be handled too
  34. #DKIMPROXY_MAXPROC_IN=5
  35. DKIMPROXY_MAXPROC_OUT=5
  36. # resolve redpill config paths
  37. realmsdir="/etc/local-$REDPILL"
  38. thisrealm=$(cat "/etc/local-$REALM/realm" || dnsdomainname | tr '[:lower:]' '[:upper:]')
  39. if ! [ -d "$realmsdir" ]; then
  40. warn "Realms directory \"$realmsdir\" does not exist."
  41. fi
  42. catfilefromownrealm() {
  43. set -e
  44. file=$1
  45. [ -d "$realmsdir" ] || exit 0
  46. cat "$realmsdir/$thisrealm/$file"
  47. }
  48. catallfilesfromotherrealms() {
  49. set -e
  50. file=$1
  51. [ -d "$realmsdir" ] || exit 0
  52. [ -f "$realmsdir/realms" ] || exit 0
  53. realms=$(sed 's/#.*//' < "$realmsdir/realms")
  54. for realm in $realms; do
  55. if [ "$thisrealm" != "$realm" ]; then
  56. cat "$realmsdir/$realm/$file"
  57. fi
  58. done
  59. }
  60. catfirstfile() {
  61. set -e
  62. file=$1
  63. context=${2:-postfix}
  64. configdir=
  65. for dir in /etc/local "/etc/local-$REALM" "/etc/local-$REDPILL" /etc/local-COMMON; do
  66. if [ -d "$dir/$context" ] && [ -f "$dir/$context/$file" ]; then
  67. configdir="$dir/$context"
  68. break
  69. fi
  70. done
  71. if [ -z "$configdir" ]; then
  72. exit1 "ERROR: file \"$file\" not found."
  73. fi
  74. cat "$configdir/$file"
  75. }
  76. # TODO: support trailing comment.
  77. getperlvarfromfile() {
  78. set -e
  79. var=$1
  80. default=$2
  81. file=$3
  82. context=${4:-postfix}
  83. catfirstfile "$file" "$context" \
  84. | var=$var default=$default perl -n \
  85. -e '/^\$$ENV{"var"}\h*=\h*(\d+)/ and $s=$1; END {print length($s) ? $s : $ENV{"default"}}'
  86. }
  87. getlinesfromfile() {
  88. set -e
  89. param=$1
  90. shift
  91. replacements=
  92. for subparam in "$@"; do
  93. case "$subparam" in
  94. *=)
  95. oldparam=$(echo "$subparam" | awk -F= '{print $1}')
  96. replacements="$replacements;s/,*[^,]*${oldparam}[^,]*,*/,/"
  97. continue
  98. ;;
  99. *=*=*)
  100. oldparam=$(echo "$subparam" | awk -F= '{print $1}')
  101. newparam=$(echo "$subparam" | awk -F= '{print $2}')
  102. newparamfile=$(echo "$subparam" | awk -F= '{print $3}')
  103. ;;
  104. *)
  105. oldparam=$subparam
  106. newparam=$subparam
  107. newparamfile=$subparam
  108. ;;
  109. esac
  110. newparamvalues=$(getlinesfromfile "$newparamfile" | sed -e 's/.*=[ ]*//' -e 's/,/ /g')
  111. newstring=
  112. for newparamvalue in $newparamvalues; do
  113. newstring="${newstring}$newparam $newparamvalue,"
  114. done
  115. replacements="$replacements;s/$oldparam/$newstring/"
  116. done
  117. printf "%s = " "$param"
  118. catfirstfile "$param" | sed 's/#.*//' | tr '\n' ',' | sed -e 's/^[, ]*//;s/[, ]\+/,/g' -e 's/\^/ /g' -e "s/,\$//$replacements"
  119. }
  120. #postgrey=
  121. #if [ -x /usr/sbin/postgrey ]; then
  122. # # FIXME: Use this somehow, and only warn below
  123. # postgrey=1
  124. #else
  125. # exit1 "ERROR: Greylisting support (Debian package postgrey) missing."
  126. #fi
  127. dovecot=
  128. dovecot_lmtp=
  129. dovecot_deliver=
  130. if [ -x /usr/sbin/dovecot ]; then
  131. dovecot=1
  132. if [ -x /usr/lib/dovecot/lmtp ]; then
  133. dovecot_lmtp=1
  134. elif [ -x /usr/lib/dovecot/deliver ]; then
  135. warn "Dovecot LMTP missing - (Debian package dovecot-lmtp)."
  136. dovecot_deliver=1
  137. else
  138. warn "Dovecot deliver missing."
  139. fi
  140. else
  141. warn "Dovecot missing - (Debian package dovecot-core or dovecot)."
  142. fi
  143. tls_cert=
  144. if [ -f "$TLS_CERT" ] && [ -f "$TLS_KEY" ]; then
  145. tls_cert=1
  146. else
  147. warn "No TLS - requires certificate \"$TLS_CERT\" and key \"$TLS_KEY\"."
  148. fi
  149. # TODO: enable only on systems with user accounts
  150. submission=1
  151. # TODO: check that dovecot SASL is configured
  152. sasl_inbound=
  153. if [ -n "$tls_cert" ] && [ -n "$dovecot" ] && [ -n "$submission" ]; then
  154. sasl_inbound=1
  155. else
  156. warn "No inbound SASL authentication - requires TLS encryption and Dovecot."
  157. fi
  158. amavis=
  159. if [ -x /usr/sbin/amavisd ] || [ -x /usr/sbin/amavisd-new ]; then
  160. amavis=1
  161. else
  162. warn "AMaViS missing (Debian package amavisd-new)."
  163. fi
  164. dkimproxy=
  165. if [ -x /usr/sbin/dkimproxy.in ]; then
  166. if [ "1" = "$amavis" ]; then
  167. dkimproxy=1
  168. else
  169. warn "No DKIM/Domainkey - requires DKIMproxy and AMaViS."
  170. fi
  171. else
  172. warn "DKIMproxy missing (Debian package dkimproxy)."
  173. fi
  174. confdir=/etc/postfix
  175. _postconf() {
  176. postconf -c "$tempdir" "$1" "$(echo "$2" | tr '\n' ' ')"
  177. }
  178. postmapfiles=
  179. tempdir=$(mktemp -td postfix.XXXXXX)
  180. cp -a -t "$tempdir" "$confdir"/*
  181. # Inspired by D. J. Bernstein: http://cr.yp.to/smtp/greeting.html
  182. _postconf -e smtpd_banner="\$myhostname NO UCE ESMTP \$mail_name (Debian/GNU)"
  183. # Some badly configured setup use hostname instead of FQDN
  184. # Disable completely: Effective, but hurts executive type guys using windows servers... :-(
  185. #if _postconf myhostname | grep -q '\.'; then
  186. # _postconf -e smtpd_helo_required=yes
  187. #fi
  188. _postconf -e smtpd_helo_required=no
  189. _postconf -e "$(getlinesfromfile permit_mx_backup_networks)"
  190. _postconf -e maps_rbl_domains=
  191. _postconf -e "$(getlinesfromfile smtpd_client_restrictions reject_rhsbl_client)"
  192. _postconf -e "$(getlinesfromfile smtpd_helo_restrictions)"
  193. _postconf -e "$(getlinesfromfile smtpd_sender_restrictions reject_rhsbl_sender ${dkimproxy:-sender_access_regex=})"
  194. _postconf -e "$(getlinesfromfile smtpd_recipient_restrictions reject_maps_rbl=reject_rbl_client=maps_rbl_domains)"
  195. _postconf -e "$(getlinesfromfile smtpd_data_restrictions)"
  196. # FIXME: clear only specific line (not whole file) when dkimproxy unused
  197. if [ -f "$tempdir/sender_access_regex" ]; then
  198. if [ -n "$dkimproxy" ]; then
  199. grep -q -F '/^/ FILTER dkimsign:[127.0.0.1]:10026' "$tempdir/sender_access_regex" \
  200. || echo '/^/ FILTER dkimsign:[127.0.0.1]:10026' >> "$tempdir/sender_access_regex"
  201. else
  202. if grep -q -F '/^/ FILTER dkimsign:[127.0.0.1]:10026' "$tempdir/sender_access_regex"; then
  203. echo "echo '' > \"$confdir/sender_access_regex\"" >> "$tempdir/COMMANDS"
  204. rm "$tempdir/sender_access_regex"
  205. fi
  206. fi
  207. postmapfiles="$postmapfiles sender_access_regex"
  208. fi
  209. # Support exceptions to default response
  210. # (Day Old Bread (dob) lists need to reject only temporarily)
  211. _postconf -e rbl_reply_maps="hash:$confdir/rbl_reply_map"
  212. sed 's/#.*//' \
  213. < /etc/local-COMMON/postfix/rbl_reply_map \
  214. > "$tempdir/rbl_reply_map"
  215. postmapfiles="$postmapfiles rbl_reply_map"
  216. # Verify senders of common suspicious and known verifiable domains
  217. # (exclude verification of postmaster@ to not verify verification probes)
  218. # (add own domains before peers for (rare) cases of duplicates)
  219. # FIXME: somehow do this step only if enabled in smtpd_sender_restrictions
  220. # TODO: Properly implement exception exclusion like yahoo (which does not want to be checked any longer!)
  221. grep -v yahoo \
  222. < /etc/local-COMMON/postfix/maildomains \
  223. | sort \
  224. | sed 's/$/ reject_unverified_sender/' \
  225. > "$tempdir/sender_access"
  226. ( catfilefromownrealm maildomains | sort; catallfilesfromotherrealms maildomains | sort ) \
  227. | sed 's/\(.*\)$/postmaster@\1 permit\n\1 reject_unverified_sender/' \
  228. >> "$tempdir/sender_access"
  229. [ ! -f "$tempdir/sender_access.addon" ] || cat "$tempdir/sender_access.addon" \
  230. >> "$tempdir/sender_access"
  231. postmapfiles="$postmapfiles sender_access"
  232. _postconf -e unverified_sender_reject_code=550
  233. # Trust recipient verification too
  234. _postconf -e unverified_recipient_reject_code=550
  235. if [ -n "$dovecot_lmtp" ]; then
  236. _postconf -e mailbox_transport=lmtp:unix:private/dovecot-lmtp
  237. _postconf -X mailbox_command
  238. elif [ -n "$dovecot_deliver" ]; then
  239. _postconf -X mailbox_transport
  240. _postconf -e mailbox_command=/usr/lib/dovecot/deliver
  241. else
  242. _postconf -X mailbox_transport
  243. _postconf -X mailbox_command
  244. fi
  245. # outbound opportunistic encryption
  246. _postconf -e smtp_tls_security_level=may
  247. if [ -n "$tls_cert" ]; then
  248. _postconf -e smtp_tls_cert_file="$TLS_CERT"
  249. _postconf -e smtp_tls_key_file="$TLS_KEY"
  250. else
  251. _postconf -X smtp_tls_cert_file
  252. _postconf -X smtp_tls_key_file
  253. fi
  254. _postconf -e smtp_tls_loglevel=1
  255. # enforce TLS trust path towards peers
  256. catallfilesfromotherrealms mailhost | sort \
  257. | sed 's/^/[/;s/$/]:submission secure/' \
  258. > "$tempdir/tls_policy"
  259. [ ! -f "$tempdir/tls_policy.addon" ] || cat "$tempdir/tls_policy.addon" \
  260. >> "$tempdir/tls_policy"
  261. postmapfiles="$postmapfiles tls_policy"
  262. _postconf -e smtp_tls_policy_maps="hash:$confdir/tls_policy"
  263. # inbound opportunistic encryption
  264. if [ -n "$tls_cert" ]; then
  265. _postconf -e smtpd_tls_security_level=may
  266. _postconf -e smtpd_tls_cert_file="$TLS_CERT"
  267. _postconf -e smtpd_tls_key_file="$TLS_KEY"
  268. _postconf -e smtpd_tls_loglevel=1
  269. _postconf -e smtpd_tls_auth_only=yes
  270. _postconf -e smtpd_tls_received_header=yes
  271. else
  272. _postconf -e smtpd_tls_security_level=none
  273. _postconf -X smtpd_tls_cert_file
  274. _postconf -X smtpd_tls_key_file
  275. _postconf -X smtpd_tls_loglevel
  276. _postconf -X smtpd_tls_auth_only
  277. _postconf -X smtpd_tls_received_header
  278. fi
  279. # Avoid smtpd_tls_CApath or smtpd_tls_CAfile to trick outlook.com
  280. # See <http://postfix.1071664.n5.nabble.com/Problems-with-incoming-mails-from-outlook-com-td78356.html>
  281. _postconf -X smtpd_tls_CApath
  282. _postconf -X smtpd_tls_CAfile
  283. # obsolete TLS-related settings
  284. _postconf -X smtpd_use_tls
  285. _postconf -X smtp_tls_CApath
  286. _postconf -X lmtp_tls_CApath
  287. _postconf -X smtp_tls_CAfile
  288. _postconf -X lmtp_tls_CAfile
  289. _postconf -X smtpd_tls_ask_ccert
  290. _postconf -X smtp_tls_note_starttls_offer
  291. _postconf -X smtpd_tls_session_cache_database
  292. _postconf -X smtpd_tls_session_cache_timeout
  293. _postconf -X smtp_tls_session_cache_database
  294. _postconf -X tls_random_exchange_name
  295. _postconf -X tls_random_source
  296. # submission
  297. # <http://www.postfix.org/SASL_README.html>
  298. # <https://doc.dovecot.org/configuration_manual/howto/postfix_and_dovecot_sasl/#using-sasl-with-postfix-submission-port>
  299. if [ -n "$submission" ]; then
  300. _postconf -Me submission/inet="
  301. submission inet n - y - - smtpd
  302. -o syslog_name=postfix/\$service_name
  303. -o smtpd_tls_security_level=encrypt
  304. "
  305. _postconf -Me smtps/inet="
  306. smtps inet n - y - - smtpd
  307. -o syslog_name=postfix/\$service_name
  308. -o smtpd_tls_wrappermode=yes
  309. -o smtpd_sasl_auth_enable=yes
  310. "
  311. if [ -n "$sasl_inbound" ]; then
  312. _postconf -Pe submission/inet/smtpd_sasl_auth_enable=yes
  313. _postconf -Pe smtps/inet/smtpd_sasl_auth_enable=yes
  314. else
  315. _postconf -PX submission/inet/smtpd_sasl_auth_enable
  316. _postconf -PX smtps/inet/smtpd_sasl_auth_enable
  317. fi
  318. else
  319. _postconf -MX submission/inet
  320. _postconf -MX smtps/inet
  321. fi
  322. if [ -n "$sasl_inbound" ]; then
  323. _postconf -e smtpd_sasl_local_domain=\$mydomain
  324. _postconf -e smtpd_sasl_type=dovecot
  325. _postconf -e smtpd_sasl_path=private/auth
  326. _postconf -e broken_sasl_auth_clients=yes
  327. else
  328. _postconf -X smtpd_sasl_local_domain
  329. _postconf -X smtpd_sasl_type
  330. _postconf -X smtpd_sasl_path
  331. _postconf -X broken_sasl_auth_clients
  332. fi
  333. # obsolete SASL-related settings
  334. _postconf -X smtpd_sasl_auth_enable
  335. _postconf -X smtpd_sasl_security_options
  336. if [ -n "$amavis" ]; then
  337. amavis_maxproc=$(getperlvarfromfile max_servers "$AMAVIS_MAXPROC" amavisd.conf.addon amavis)
  338. _postconf -Me amavisfeed/unix="
  339. amavisfeed unix - - n - $amavis_maxproc lmtp
  340. -o lmtp_data_done_timeout=1200s
  341. -o lmtp_send_xforward_command=yes
  342. -o disable_dns_lookups=yes
  343. -o max_use=$amavis_maxproc
  344. "
  345. _postconf -Me 127.0.0.1:10025/inet='
  346. 127.0.0.1:10025 inet n - n - - smtpd
  347. -o content_filter=
  348. -o local_recipient_maps=
  349. -o relay_recipient_maps=
  350. -o smtpd_restriction_classes=
  351. -o smtpd_delay_reject=no
  352. -o smtpd_client_restrictions=permit_mynetworks,reject
  353. -o smtpd_helo_restrictions=
  354. -o smtpd_sender_restrictions=
  355. -o smtpd_recipient_restrictions=permit_mynetworks,reject
  356. -o smtpd_data_restrictions=reject_unauth_pipelining
  357. -o smtpd_end_of_data_restrictions=
  358. -o mynetworks=127.0.0.0/8
  359. -o smtpd_error_sleep_time=0
  360. -o smtpd_soft_error_limit=1001
  361. -o smtpd_hard_error_limit=1000
  362. -o smtpd_client_connection_count_limit=0
  363. -o smtpd_client_connection_rate_limit=0
  364. -o receive_override_options=no_unknown_recipient_checks,no_header_body_checks,no_milters
  365. '
  366. _postconf -e receive_override_options=no_address_mappings
  367. if [ -n "$dkimproxy" ]; then
  368. _postconf -e content_filter='amavisfeed:[127.0.0.1]:10028'
  369. _postconf -Pe pickup/fifo/content_filter='dkimsign:127.0.0.1:10028'
  370. if [ -n "$submission" ]; then
  371. _postconf -Pe submission/inet/content_filter='dkimsign:[127.0.0.1]:10028'
  372. _postconf -Pe smtps/inet/content_filter='dkimsign:[127.0.0.1]:10028'
  373. fi
  374. # FIXME: supersede DKIMPROXY_MAXPROC_OUT from /etc/default/dkimproxy
  375. _postconf -Me dkimsign/unix="
  376. dkimsign unix - - n - $DKIMPROXY_MAXPROC_OUT smtp
  377. -o smtp_send_xforward_command=yes
  378. -o smtp_discard_ehlo_keywords=8bitmime,starttls
  379. "
  380. _postconf -Me 127.0.0.1:10029/inet='
  381. 127.0.0.1:10029 inet n - n - - smtpd
  382. -o content_filter=
  383. -o receive_override_options=no_unknown_recipient_checks,no_header_body_checks,no_milters
  384. -o smtpd_helo_restrictions=
  385. -o smtpd_client_restrictions=
  386. -o smtpd_sender_restrictions=
  387. -o smtpd_recipient_restrictions=permit_mynetworks,reject
  388. -o mynetworks=127.0.0.0/8
  389. -o smtpd_authorized_xforward_hosts=127.0.0.0/8
  390. '
  391. else
  392. _postconf -MX dkimsign/unix
  393. _postconf -MX 127.0.0.1:10029/inet
  394. _postconf -e content_filter='amavisfeed:[127.0.0.1]:10024'
  395. _postconf -PX pickup/fifo/content_filter
  396. if [ -n "$submission" ]; then
  397. _postconf -PX submission/inet/content_filter
  398. _postconf -PX smtps/inet/content_filter
  399. fi
  400. fi
  401. else
  402. _postconf -MX amavisfeed/unix
  403. _postconf -MX 127.0.0.1:10025/inet
  404. _postconf -X content_filter
  405. _postconf -X receive_override_options
  406. fi
  407. # obsolete settings
  408. _postconf -X max_use
  409. _postconf -MX smtp-amavis/unix
  410. diff -ruNw "$confdir" "$tempdir" || if [ $? -gt 1 ]; then exit $?; else needs_reload=1; fi
  411. if [ "1" = "$FORCE" ]; then
  412. do_update=y
  413. elif [ "1" = "$needs_reload" ]; then
  414. printf 'Above is the intended changes. OK to update (y/N)? '
  415. read -r do_update
  416. fi
  417. case $do_update in
  418. y|Y)
  419. if [ -f "$tempdir/COMMANDS" ]; then
  420. sh -s < "$tempdir/COMMANDS"
  421. fi
  422. rm -f "$tempdir/COMMANDS"
  423. diff -q "$confdir/master.cf" "$tempdir/master.cf" || if [ $? -gt 1 ]; then exit $?; else needs_restart=1; fi
  424. cp -a -f -t "$confdir" "$tempdir"/*
  425. rm -rf "$tempdir"
  426. for file in $postmapfiles; do
  427. postmap "$confdir/$file"
  428. done
  429. if [ "1" = "$needs_restart" ]; then
  430. service postfix restart
  431. else
  432. service postfix force-reload
  433. fi
  434. if [ "1" = "$needs_reload" ]; then
  435. echo >&2 "Changes applied!"
  436. fi
  437. ;;
  438. *)
  439. if [ "1" = "$needs_reload" ]; then
  440. exit1 "Aborted!"
  441. fi
  442. ;;
  443. esac
  444. if [ "1" != "$needs_reload" ]; then
  445. echo >&2 "No changes needed!"
  446. fi
  447. # Based on this: http://jimsun.linxnet.com/misc/postfix-anti-UCE.txt
  448. # Support for trusted MX backup networks added
  449. # PCRE stuff avoided, as PCRE is only optional on newest Debian packages
  450. # RBLs replaced with those recommended by http://www.antispews.org/
  451. # spam filter based on these: http://www.postfix.org/FILTER_README.html
  452. # https://www.ijs.si/software/amavisd/amavisd-new-docs.html
  453. # TLS based on this: http://www.postfix.org/TLS_README.html
  454. # Here's a convenient overview of different blackholes:
  455. # http://rbls.org/